
class Vector {

  var x:Number = 0;
  var y:Number = 0;
  var z:Number = 0;
  
  // Constructor function
  function Vector( x_:Number, y_:Number, z_:Number ) {
    x = x_;
    y = y_;
    z = z_;
  }


  // Methods
  function info():String {
    return( "V: " + x + "," + y + "," + z );
  }

  

  function set( v:Vector ) {
    x = v.x;  y = v.y;  z = v.z;
  }
  function copy():Vector {
    return new Vector( x, y, z );
  }

  function plus( v:Vector ) {
    x += v.x;  y += v.y;  z += v.z;
  }
  function minus( v:Vector ) {
    x -= v.x;  y -= v.y;  z -= v.z;
  }
  function mult( k:Number ) {
    x *= k;  y *= k;  z *= k;
  }


  function dot( v:Vector ) {
    return( x*v.x + y*v.y + z*v.z );
  }

  
  function multM( m:Matrix ) {
    var X = x*m.m[0][0] + y*m.m[1][0] + z*m.m[2][0] + m.m[3][0];
    var Y = x*m.m[0][1] + y*m.m[1][1] + z*m.m[2][1] + m.m[3][1];
    var Z = x*m.m[0][2] + y*m.m[1][2] + z*m.m[2][2] + m.m[3][2];
    var W = x*m.m[0][3] + y*m.m[1][3] + z*m.m[2][3] + m.m[3][3];
    if( W<>0 ) {
      x = X/W;
      y = Y/W;
      z = Z/W;
    }
  }

}

